<?php
require_once "conexion.php";
class ModeloEmpresas{

  /*MOSTRAR Empresas*/

  static public function mdlMostrarEmpresas($tabla,$item,$valor){

    if ($item != null) {

      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla WHERE $item = :$item");

      $stmt -> bindParam(":".$item,$valor, PDO::PARAM_STR);

      $stmt ->execute();

      return $stmt ->fetchall(); //Verificar que no falle en otro formulario donde se ocupe los datos de la empresa where un id

    }else {
      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla");

      $stmt ->execute();

      return $stmt ->fetchall();

    }


    $stmt->close();

    $stmt=null;
  }

  /*REGISTRO DE USUARIOS*/
  static public function mdlIngresarEmpresa($tabla,$datos,$ajax){

    $stmt = Conexion::conectar()->prepare("INSERT INTO $tabla(emp_nombre, emp_direccion, emp_cp, emp_ciudad, emp_estado, emp_telefono, emp_rfc, emp_razonSocial, id_divisa, emp_correoElectronico, emp_tipoContribuyente) VALUES (:emp_nombre, :emp_direccion, :emp_cp, :emp_ciudad, :emp_estado, :emp_telefono, :emp_rfc, :emp_razonSocial, :id_divisa, :emp_correoElectronico, :emp_tipoContribuyente)");

      $stmt->bindParam(":emp_nombre", $datos["emp_nombre"], PDO::PARAM_STR);
  		$stmt->bindParam(":emp_direccion", $datos["emp_direccion"], PDO::PARAM_STR);
  		$stmt->bindParam(":emp_cp", $datos["emp_cp"], PDO::PARAM_STR);
  		$stmt->bindParam(":emp_ciudad", $datos["emp_ciudad"], PDO::PARAM_STR);
      $stmt->bindParam(":emp_estado", $datos["emp_estado"], PDO::PARAM_STR);
      $stmt->bindParam(":emp_telefono", $datos["emp_telefono"], PDO::PARAM_STR);
      $stmt->bindParam(":emp_rfc", $datos["emp_rfc"], PDO::PARAM_STR);

      $stmt->bindParam(":emp_razonSocial", $datos["emp_razonSocial"], PDO::PARAM_STR);
      $stmt->bindParam(":id_divisa", $datos["id_divisa"], PDO::PARAM_STR);
      $stmt->bindParam(":emp_tipoContribuyente", $datos["emp_tipoContribuyente"], PDO::PARAM_STR);
      $stmt->bindParam(":emp_correoElectronico", $datos["emp_correoElectronico"], PDO::PARAM_STR);


      if($stmt->execute()){
          if ($ajax == "si") {
            $id[0] = ModeloEmpresas::mdlGetUltimoIdEmpresa($tabla);
            return $id;
          }
          else{
            return "ok";

          }

      }else{
        var_dump($stmt -> errorInfo());exit;
        return "error";

      }

      $stmt->close();

      $stmt = null;

  }

  /*=============================================
    GET A ULTIMA EMPRESA ASIGNADA
  =============================================*/
  static public function mdlGetUltimoIdEmpresa($tabla){


      $stmt = conexion::conectar()->prepare("SELECT id_empresa  FROM $tabla  order by id_empresa desc  limit 1");
        $stmt->execute();
        $resultado = $stmt ->fetch();

        if($resultado != false){
                return $resultado;
        }
    $stmt->close();
    $stmt=null;
  }
  /*=============================================
	EDITAR USUARIO
	=============================================*/
	static public function mdlEditarEmpresa($tabla, $datos){

		$stmt = Conexion::conectar()->prepare("UPDATE $tabla SET emp_nombre = :emp_nombre, emp_direccion = :emp_direccion, emp_cp = :emp_cp, emp_ciudad = :emp_ciudad, emp_estado = :emp_estado, emp_telefono = :emp_telefono, emp_rfc = :emp_rfc, emp_razonSocial = :emp_razonSocial, emp_correoElectronico = :emp_correoElectronico, id_divisa = :id_divisa, emp_tipoContribuyente = :emp_tipoContribuyente WHERE id_empresa = :id_empresa");

    $stmt->bindParam(":id_empresa", $datos["id_empresa"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_nombre", $datos["emp_nombre"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_direccion", $datos["emp_direccion"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_cp", $datos["emp_cp"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_ciudad", $datos["emp_ciudad"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_estado", $datos["emp_estado"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_telefono", $datos["emp_telefono"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_rfc", $datos["emp_rfc"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_razonSocial", $datos["emp_razonSocial"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_correoElectronico", $datos["emp_correoElectronico"], PDO::PARAM_STR);
    $stmt->bindParam(":emp_tipoContribuyente", $datos["emp_tipoContribuyente"], PDO::PARAM_STR);
    $stmt->bindParam(":id_divisa", $datos["id_divisa"], PDO::PARAM_STR);

		if($stmt -> execute()){
			return "ok";
		}else{
			return "error";
		}

		$stmt -> close();
		$stmt = null;
	}
  /*=============================================
	BORRAR USUARIO
	=============================================*/
	static public function mdlBorrarEmpresa($tabla, $datos){

		$stmt = Conexion::conectar()->prepare("DELETE FROM $tabla WHERE id_empresa = :id_empresa");

		$stmt -> bindParam(":id_empresa", $datos, PDO::PARAM_INT);

		if($stmt -> execute()){
			return "ok";
		}else{
			return "error";
		}

		$stmt -> close();
		$stmt = null;
	}
  /*=============================================
    MOSTRAR DATOS DEL CATALOGO cat_divisas
  =============================================*/
  static public function mdlMostrarDivisas($tabla,$item,$valor){

    if ($item != null) {
      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla WHERE $item = :$item");
      $stmt -> bindParam(":".$item,$valor, PDO::PARAM_STR);
      $stmt ->execute();
      return $stmt ->fetchall();

    }else {
      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla");
      $stmt ->execute();
      return $stmt ->fetchall();
    }

    $stmt->close();
    $stmt=null;
  }
}
