<?php
require_once "conexion.php";

class ModeloUsuarios{

  /*MOSTRAR USUARIOS*/

  static public function mdlMostrarUsuarios($tabla,$item,$valor){


    if ($item != null) {
      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla as u inner join tbl_roles as r on u.us_rol = r.id_rol WHERE $item = :$item");

      $stmt -> bindParam(":".$item,$valor, PDO::PARAM_STR);

      $stmt ->execute();

      return $stmt ->fetch();

    }else {
      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla as u inner join tbl_roles as r on u.us_rol = r.id_rol");

      $stmt ->execute();

      return $stmt ->fetchall();

    }

    $stmt->close();
    $stmt=null;
  }
  /*MOSTRAR USUARIOS*/

  static public function mdlMostrarUsuarios_Solicitudes($tabla,$item,$valor){

      $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla as u inner join tbl_roles as r on u.us_rol = r.id_rol WHERE $item = :$item");

      $stmt -> bindParam(":".$item,$valor, PDO::PARAM_STR);

      $stmt ->execute();

      return $stmt ->fetchall();
      $stmt->close();
      $stmt=null;
  }

    /*MOSTRAR USUARIOS*/

    static public function mdlMostrarRoles($tabla,$item,$valor){

      if ($item != null) {
        $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla WHERE $item = :$item");
        $stmt -> bindParam(":".$item,$valor, PDO::PARAM_STR);
        $stmt ->execute();
        return $stmt ->fetch();

      }else {
        $stmt = conexion::conectar()->prepare("SELECT * FROM $tabla");
        $stmt ->execute();
        return $stmt ->fetchall();
      }
      $stmt->close();
      $stmt=null;
    }

  /*REGISTRO DE USUARIOS*/
  static public function mdlIngresarUsuario($tabla,$datos){

    $stmt = Conexion::conectar()->prepare("INSERT INTO $tabla(us_nombre, us_usuario, us_password, us_rol,us_foto, us_correo) VALUES (:us_nombre, :us_usuario, :us_password, :us_rol, :us_foto, :us_correo)");

      $stmt->bindParam(":us_nombre", $datos["us_nombre"], PDO::PARAM_STR);
  		$stmt->bindParam(":us_usuario", $datos["us_usuario"], PDO::PARAM_STR);
  		$stmt->bindParam(":us_password", $datos["us_password"], PDO::PARAM_STR);
  		$stmt->bindParam(":us_rol", $datos["us_rol"], PDO::PARAM_STR);
      $stmt->bindParam(":us_correo", $datos["us_correo"], PDO::PARAM_STR);
      $stmt->bindParam(":us_foto", $datos["us_foto"], PDO::PARAM_STR);

      if($stmt->execute()){

        return "ok";

      }else{

        return "error";

      }

      $stmt->close();

      $stmt = null;

  }


  /*=============================================
	EDITAR USUARIO
	=============================================*/

	static public function mdlEditarUsuario($tabla, $datos){

		$stmt = Conexion::conectar()->prepare("UPDATE $tabla SET us_nombre = :us_nombre, us_password = :us_password, us_rol = :us_rol, us_foto = :us_foto, us_correo = :us_correo WHERE us_usuario = :us_usuario");

		$stmt -> bindParam(":us_nombre", $datos["us_nombre"], PDO::PARAM_STR);
		$stmt -> bindParam(":us_password", $datos["us_password"], PDO::PARAM_STR);
		$stmt -> bindParam(":us_rol", $datos["us_rol"], PDO::PARAM_STR);
		$stmt -> bindParam(":us_foto", $datos["us_foto"], PDO::PARAM_STR);
		$stmt -> bindParam(":us_usuario", $datos["us_usuario"], PDO::PARAM_STR);
    $stmt->bindParam(":us_correo", $datos["us_correo"], PDO::PARAM_STR);

		if($stmt -> execute()){

			return "ok";

		}else{

			return "error";

		}

		$stmt -> close();

		$stmt = null;

	}

	/*=============================================
	ACTUALIZAR USUARIO
	=============================================*/

	static public function mdlActualizarUsuario($tabla, $item1, $valor1, $item2, $valor2){

		$stmt = Conexion::conectar()->prepare("UPDATE $tabla SET $item1 = :$item1 WHERE $item2 = :$item2");

		$stmt -> bindParam(":".$item1, $valor1, PDO::PARAM_STR);
		$stmt -> bindParam(":".$item2, $valor2, PDO::PARAM_STR);

		if($stmt -> execute()){

			return "ok";

		}else{

			return "error";

		}

		$stmt -> close();

		$stmt = null;

	}

  /*=============================================
	BORRAR USUARIO
	=============================================*/

	static public function mdlBorrarUsuario($tabla, $datos){

		$stmt = Conexion::conectar()->prepare("DELETE FROM $tabla WHERE id_usuario = :us_id");

		$stmt -> bindParam(":us_id", $datos, PDO::PARAM_INT);

		if($stmt -> execute()){

			return "ok";
		}else{


			return "error";

		}

		$stmt -> close();

		$stmt = null;


	}


}
